<ui:composition xmlns:g="http://www.ihe.net/gazelle"
                xmlns:h="http://java.sun.com/jsf/html"
                xmlns:f="http://java.sun.com/jsf/core"
                xmlns:a4j="http://richfaces.org/a4j"
                xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:rich="http://richfaces.org/rich"
                xmlns="http://www.w3.org/1999/xhtml" template="/layout/template.xhtml">
    <ui:define name="body">
        <ui:decorate template="_template.xhtml">
            <ui:param name="pageName" value="integrationProfile"/>
            <ui:param name="controllerName" value="#{appliesToIntegrationProfileManager}"/>
            <ui:param name="tabId" value="menuTabs"/>
            <ui:param name="linkEntityFilterDivTitle"
                      value="#{messages['net.ihe.gazelle.assertion-manager.IntegrationProfilesFilter']}"/>
            <ui:define name="linkEntityFilterDiv">
                <h:form id="filterform" styleClass="form-horizontal">
                    <s:decorate template="/layout/form/_form_field_horizontal_inline.xhtml">
                        <ui:param name="id" value="domain"/>
                        <ui:define name="label">#{messages['net.ihe.gazelle.assertion-manager.Domain']}</ui:define>
                        <h:selectOneMenu id="domain" styleClass="form-control gzl-select-text"
                                         value="#{appliesToIntegrationProfileManager.selectedDomain}">
                            <s:selectItems var="domainAvailable"
                                           label="#{domainAvailable}"
                                           value="#{appliesToIntegrationProfileManager.getDomainsAvailable()}"
                                           noSelectionLabel="#{messages['gazelle.common.button.ShowAll']}"/>
                            <a4j:ajax event="change" execute="@this"
                                      render="filterform,integrationProfilesForm,description,idSchemesForm"/>
                        </h:selectOneMenu>
                    </s:decorate>

                </h:form>
            </ui:define>
            <ui:define name="idSchemeFilterPanel">
                <ui:include src="_assertionsFilters.xhtml">
                    <ui:param name="filterParam" value="#{appliesToIntegrationProfileManager.filter}"/>
                    <ui:param name="idSchemeIdToRefresh" value="idSchemesForm,menuTabs"/>
                </ui:include>
            </ui:define>
            <ui:define name="linkingEntityFold">
                <div class="col-md-3">
                    <h:form id="integrationProfilesForm">
                        <s:decorate template="/layout/panels/_panel_title.xhtml">
                            <ui:define name="panel_title">
                                <h:outputText
                                        value="#{appliesToIntegrationProfileManager.getIntegrationProfiles().size()}  #{messages['net.ihe.gazelle.assertion-manager.IntegrationProfilesFor']} #{appliesToIntegrationProfileManager.selectedDomain} #{messages['net.ihe.gazelle.assertion-manager.Domain']}"/>
                            </ui:define>
                            <rich:dataTable rows="20" id="idTests"
                                            var="currentIntegrationProfile"
                                            value="#{appliesToIntegrationProfileManager.getIntegrationProfiles()}"
                                            render="idTestsDs">
                                <f:facet name="header">

                                </f:facet>
                                <g:column sortBy="#{'keyword'}">
                                    <ui:define name="header">
                                        #{messages['net.ihe.gazelle.assertion-manager.IntegrationProfile']}
                                    </ui:define>
                                    <h:outputText
                                            value="#{currentIntegrationProfile.keyword} - #{currentIntegrationProfile.name}"
                                            style="#{appliesToIntegrationProfileManager.getSelectedIntegrationProfile().getId() == currentIntegrationProfile.getId() ? 'font-weight:bold;' : ''}"/>
                                </g:column>
                                <g:column>
                                    <ui:define name="header">#{messages['net.ihe.gazelle.assertion-manager.Covered']}
                                    </ui:define>
                                    <h:outputText
                                            value="#{appliesToIntegrationProfileManager.isIntegrationProfileCovered(currentIntegrationProfile.keyword)}"/>
                                </g:column>
                                <g:column>
                                    <a4j:commandLink
                                            value="#{messages['net.ihe.gazelle.assertion-manager.Select']}"
                                            immdediate="true"
                                            actionListener="#{appliesToIntegrationProfileManager.setSelectedIntegrationProfile(currentIntegrationProfile)}"
                                            render="description,idSchemesForm,integrationProfilesForm,ruleCoverage"/>
                                </g:column>
                                <f:facet name="footer">
                                    <ui:include src="/util/datatableFooter.xhtml">
                                        <ui:param name="dataScrollerId" value="idTestsDs"/>
                                        <ui:param name="dataTableId" value="idTests"/>
                                        <ui:param name="hideRowsSelect" value="true"/>
                                        <ui:param name="maxPages" value="5"/>
                                    </ui:include>
                                </f:facet>
                            </rich:dataTable>
                        </s:decorate>
                    </h:form>
                </div>
                <div class="col-md-4">
                    <h:form id="description">
                        <h:panelGroup
                                rendered="#{appliesToIntegrationProfileManager.isIntegrationProfileSelected()}">
                            <ui:decorate template="/layout/panels/_panel_title.xhtml">
                                <ui:define name="panel_title">
                                    <h:outputText
                                            value="#{messages['net.ihe.gazelle.assertion-manager.DescriptionOf']} #{appliesToIntegrationProfileManager.getSelectedIntegrationProfile().getName()} "/>
                                </ui:define>
                                <g:safehtml
                                        value="#{appliesToIntegrationProfileManager.getSelectedIntegrationProfileDescription()}"/>
                            </ui:decorate>
                            <ui:decorate template="/layout/panels/_panel_title.xhtml">
                                <ui:define name="panel_title">
                                    #{messages['net.ihe.gazelle.assertion-manager.IntegrationProfile']}
                                    (#{appliesToIntegrationProfileManager.getSelectedIntegrationProfile().getKeyword()})
                                    #{messages['net.ihe.gazelle.assertion-manager.IsLinkedToThoseAssertions']}
                                </ui:define>
                                <rich:dataTable rows="20" id="ruleCoverage"
                                                var="assertionCoverage"
                                                rendered="#{appliesToIntegrationProfileManager.isIntegrationProfileSelected()}"
                                                value="#{appliesToIntegrationProfileManager.assertionsOfSelectedIntegrationProfile()}">
                                    <g:column id="action">
                                        <a4j:commandButton styleClass="btn-sm gzl-btn-red"
                                                           rendered="#{appliesToIntegrationProfileManager.isSelectedIntegrationProfileLinkedTo(assertionCoverage.assertion.id)}"
                                                           actionListener="#{appliesToIntegrationProfileManager.unlinkSelectedIntegrationProfileFrom(assertionCoverage.assertion.id)}"
                                                           immdediate="true"
                                                           value="#{messages['net.ihe.gazelle.assertion-manager.Unlink']}"
                                                           render="action,integrationProfilesForm,description,idSchemesForm"/>
                                    </g:column>
                                    <g:column
                                            sortBy="#{assertionCoverage.assertion.target.idScheme}"
                                            sortOrder="ascending">
                                        <ui:define name="header">
                                            #{messages['net.ihe.gazelle.assertion-manager.SelectIdScheme']}
                                        </ui:define>
                                        <a4j:commandLink immdediate="true"
                                                         value="#{assertionCoverage.assertion.target.idScheme}"
                                                         actionListener="#{appliesToIntegrationProfileManager.setSelectedIdScheme(assertionCoverage.assertion.target.idScheme)}"
                                                         render="idSchemesForm,description,filterform"/>
                                    </g:column>
                                    <g:column sortBy="#{assertionCoverage.assertion.assertionId}"
                                              sortOrder="ascending">
                                        <ui:define name="header">
                                            #{messages['net.ihe.gazelle.assertion-manager.AssertionId']}
                                        </ui:define>
                                        <h:outputLink id="linkAssertion" target="_assertion"
                                                      title="#{messages['net.ihe.gazelle.assertion-manager.ViewAssertion']}"
                                                      value="#{request.contextPath}/assertions/show.seam">
                                            <f:param name="id" value="#{assertionCoverage.assertion.id}"/>
                                            <h:outputText
                                                    value="#{assertionCoverage.assertion.assertionId}"/>
                                        </h:outputLink>
                                    </g:column>
                                </rich:dataTable>
                            </ui:decorate>
                        </h:panelGroup>
                    </h:form>
                </div>
                <div class="col-md-5">
                    <h:form id="idSchemesForm">
                        <s:decorate template="/layout/panels/_panel_title.xhtml">
                            <ui:define name="panel_title">
                                Assertions
                            </ui:define>
                            <ui:include src="../_linkAll.xhtml">
                                <ui:param name="manager" value="#{appliesToIntegrationProfileManager}"/>
                            </ui:include>
                            <rich:dataTable rows="20" id="idScheme" var="assertion"
                                            value="#{appliesToIntegrationProfileManager.assertions}"
                                            render="idSchemeDs">
                                <g:column id="action"
                                          rendered="#{appliesToIntegrationProfileManager.isIntegrationProfileSelected()}">
                                    <a4j:commandButton styleClass="btn-sm gzl-btn-green"
                                                       disabled="#{!appliesToIntegrationProfileManager.isIntegrationProfileSelected()}"
                                                       rendered="#{not appliesToIntegrationProfileManager.isSelectedIntegrationProfileLinkedTo(assertion.id) }"
                                                       actionListener="#{appliesToIntegrationProfileManager.linkSelectedIntegrationProfileTo(assertion.id)}"
                                                       immdediate="true"
                                                       value="#{messages['net.ihe.gazelle.assertion-manager.LinkTo']}"
                                                       render="idSchemesForm,integrationProfilesForm,description"/>
                                    <a4j:commandButton styleClass="btn-sm gzl-btn-red"
                                                       disabled="#{!appliesToIntegrationProfileManager.isIntegrationProfileSelected()}"
                                                       rendered="#{appliesToIntegrationProfileManager.isSelectedIntegrationProfileLinkedTo(assertion.id)}"
                                                       actionListener="#{appliesToIntegrationProfileManager.unlinkSelectedIntegrationProfileFrom(assertion.id)}"
                                                       immdediate="true"
                                                       value="#{messages['net.ihe.gazelle.assertion-manager.Unlink']}"
                                                       render="idSchemesForm,integrationProfilesForm,description"/>
                                </g:column>
                                <ui:include src="_applyAssertionsTable.xhtml">
                                    <ui:param name="assertionParam" value="#{assertion}"/>
                                </ui:include>
                                <f:facet name="footer">
                                    <ui:include src="/util/datatableFooter.xhtml">
                                        <ui:param name="dataScrollerId" value="idSchemeDs"/>
                                        <ui:param name="dataTableId" value="idScheme"/>
                                        <ui:param name="hideRowsSelect" value="true"/>
                                        <ui:param name="maxPages" value="5"/>
                                    </ui:include>
                                </f:facet>
                            </rich:dataTable>
                        </s:decorate>
                    </h:form>
                    <ui:include src="../_linkAllPopup.xhtml">
                        <ui:param name="manager" value="#{appliesToIntegrationProfileManager}"/>
                        <ui:param name="formToRender" value="integrationProfilesForm"/>
                    </ui:include>
                </div>
            </ui:define>
        </ui:decorate>
    </ui:define>
</ui:composition>
